diff --git a/gcc/config/c6x/c6x.c b/gcc/config/c6x/c6x.c
index 9ba10df..3508e40 100644
--- a/gcc/config/c6x/c6x.c
+++ b/gcc/config/c6x/c6x.c
@@ -222,25 +222,25 @@ c6x_option_override (void)
       c6x_insn_mask |= all_isas[c6x_arch_option].features;
     }
 
-  c6x_flag_schedule_insns2 = flag_schedule_insns_after_reload;
-  flag_schedule_insns_after_reload = 0;
+  c6x_flag_schedule_insns2 = GCC_OPTION (flag_schedule_insns_after_reload);
+  GCC_OPTION (flag_schedule_insns_after_reload) = 0;
 
-  c6x_flag_modulo_sched = flag_modulo_sched;
-  flag_modulo_sched = 0;
+  c6x_flag_modulo_sched = GCC_OPTION (flag_modulo_sched);
+  GCC_OPTION (flag_modulo_sched) = 0;
 
   init_machine_status = c6x_init_machine_status;
 
   for (i = 0; i < ARRAY_SIZE (c6x_unit_names); i++)
     c6x_unit_codes[i] = get_cpu_unit_code (c6x_unit_names[i]);
 
-  if (flag_pic && !TARGET_DSBT)
+  if (GCC_OPTION (flag_pic) && !TARGET_DSBT)
     {
       error ("-fpic and -fPIC not supported without -mdsbt on this target");
-      flag_pic = 0;
+      GCC_OPTION (flag_pic) = 0;
     }
-  c6x_initial_flag_pic = flag_pic;
-  if (TARGET_DSBT && !flag_pic)
-    flag_pic = 1;
+  c6x_initial_flag_pic = GCC_OPTION (flag_pic);
+  if (TARGET_DSBT && !GCC_OPTION (flag_pic))
+    GCC_OPTION (flag_pic) = 1;
 }
 
 
@@ -389,8 +389,8 @@ c6x_file_start (void)
      of insns.  It also needs a valid CFG.  This can't be done in
      c6x_override_options, because flag_var_tracking is finalized after
      that.  */
-  c6x_flag_var_tracking = flag_var_tracking;
-  flag_var_tracking = 0;
+  c6x_flag_var_tracking = GCC_OPTION (flag_var_tracking);
+  GCC_OPTION (flag_var_tracking) = 0;
 
   done_cfi_sections = false;
   default_file_start ();
@@ -431,10 +431,10 @@ c6x_output_file_unwind (FILE * f)
   /* Output a .cfi_sections directive.  */
   if (dwarf2out_do_frame ())
     {
-      if (flag_unwind_tables || flag_exceptions)
+      if (GCC_OPTION (flag_unwind_tables) || GCC_OPTION (flag_exceptions))
 	{
-	  if (write_symbols == DWARF2_DEBUG
-	      || write_symbols == VMS_AND_DWARF2_DEBUG)
+	  if (GCC_OPTION (write_symbols) == DWARF2_DEBUG
+	      || GCC_OPTION (write_symbols) == VMS_AND_DWARF2_DEBUG)
 	    asm_fprintf (f, "\t.cfi_sections .debug_frame, .c6xabi.exidx\n");
 	  else
 	    asm_fprintf (f, "\t.cfi_sections .c6xabi.exidx\n");
@@ -451,11 +451,11 @@ static void
 c6x_output_fn_unwind (FILE * f)
 {
   /* Return immediately if we are not generating unwinding tables.  */
-  if (! (flag_unwind_tables || flag_exceptions))
+  if (! (GCC_OPTION (flag_unwind_tables) || GCC_OPTION (flag_exceptions)))
     return;
 
   /* If this function will never be unwound, then mark it as such.  */
-  if (!(flag_unwind_tables || crtl->uses_eh_lsda)
+  if (!(GCC_OPTION (flag_unwind_tables) || crtl->uses_eh_lsda)
       && (TREE_NOTHROW (current_function_decl)
 	  || crtl->all_throwers_are_sibcalls))
     fputs("\t.cantunwind\n", f);
@@ -751,7 +751,7 @@ c6x_can_output_mi_thunk (const_tree thunk ATTRIBUTE_UNUSED,
 			 HOST_WIDE_INT vcall_offset ATTRIBUTE_UNUSED,
 			 const_tree function ATTRIBUTE_UNUSED)
 {
-  return !TARGET_LONG_CALLS;
+  return !GCC_OPTION (TARGET_LONG_CALLS);
 }
 
 /* Output the assembler code for a thunk function.  THUNK is the
@@ -895,8 +895,8 @@ static section *
 c6x_select_rtx_section (enum machine_mode mode, rtx x,
 			unsigned HOST_WIDE_INT align)
 {
-  if (c6x_sdata_mode == C6X_SDATA_ALL
-      || (c6x_sdata_mode != C6X_SDATA_NONE && GET_MODE_SIZE (mode) <= 8))
+  if (GCC_OPTION (c6x_sdata_mode) == C6X_SDATA_ALL
+      || (GCC_OPTION (c6x_sdata_mode) != C6X_SDATA_NONE && GET_MODE_SIZE (mode) <= 8))
     /* ??? Consider using mergeable sdata sections.  */
     return sdata_section;
   else
@@ -1162,7 +1162,7 @@ c6x_function_ok_for_sibcall (tree decl, tree exp)
   if (c6x_call_saved_register_used (exp))
     return false;
 
-  if (!flag_pic)
+  if (!GCC_OPTION (flag_pic))
     return true;
 
   if (TARGET_DSBT)
@@ -1202,7 +1202,7 @@ c6x_function_in_section_p (tree decl, section *section)
   if (!DECL_SECTION_NAME (decl))
     {
       /* Make sure that we will not create a unique section for DECL.  */
-      if (flag_function_sections || DECL_ONE_ONLY (decl))
+      if (GCC_OPTION (flag_function_sections) || DECL_ONE_ONLY (decl))
 	return false;
     }
 
@@ -1216,7 +1216,7 @@ c6x_long_call_p (rtx op)
 {
   tree decl;
 
-  if (!TARGET_LONG_CALLS)
+  if (!GCC_OPTION (TARGET_LONG_CALLS))
     return false;
 
   decl = SYMBOL_REF_DECL (op);
@@ -1225,7 +1225,7 @@ c6x_long_call_p (rtx op)
      function.  Be conservative, and only cater for cases in which the
      whole of the current function is placed in the same section.  */
   if (decl != NULL_TREE
-      && !flag_reorder_blocks_and_partition
+      && !GCC_OPTION (flag_reorder_blocks_and_partition)
       && TREE_CODE (decl) == FUNCTION_DECL
       && c6x_function_in_section_p (decl, current_function_section ()))
     return false;
@@ -1260,7 +1260,7 @@ c6x_expand_call (rtx retval, rtx address, bool sibcall)
 	call_insn = emit_call_insn (gen_rtx_SET (GET_MODE (retval), retval,
 						 call_insn));
     }
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     use_reg (&CALL_INSN_FUNCTION_USAGE (call_insn), pic_offset_table_rtx);
 }
 
@@ -1286,7 +1286,7 @@ legitimize_pic_address (rtx orig, rtx reg, rtx picreg)
 	  gcc_assert (can_create_pseudo_p ());
 	  reg = gen_reg_rtx (Pmode);
 	}
-      if (flag_pic == 2)
+      if (GCC_OPTION (flag_pic) == 2)
 	{
 	  if (can_create_pseudo_p ())
 	    tmp = gen_reg_rtx (Pmode);
@@ -1365,7 +1365,7 @@ expand_move (rtx *operands, enum machine_mode mode)
     operands[1] = force_reg (mode, op);
   else if (mode == SImode && symbolic_operand (op, SImode))
     {
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	{
 	  if (sdata_symbolic_operand (op, SImode))
 	    {
@@ -1484,7 +1484,7 @@ c6x_expand_compare (rtx comparison, enum machine_mode mode)
 	}
       cmp = cmp1;
     }
-  else if (TARGET_FP && !flag_finite_math_only
+  else if (TARGET_FP && !GCC_OPTION (flag_finite_math_only)
 	   && (op_mode == DFmode || op_mode == SFmode)
 	   && code != EQ && code != NE && code != LT && code != GT
 	   && code != UNLE && code != UNGE)
@@ -2409,13 +2409,13 @@ c6x_legitimate_address_p_1 (enum machine_mode mode, rtx x, bool strict,
       else
 	size = GET_MODE_SIZE (mode);
 
-      if (flag_pic
+      if (GCC_OPTION (flag_pic)
 	  && GET_CODE (XEXP (x, 1)) == UNSPEC
 	  && XINT (XEXP (x, 1), 1) == UNSPEC_LOAD_SDATA
 	  && XEXP (x, 0) == pic_offset_table_rtx
 	  && sdata_symbolic_operand (XVECEXP (XEXP (x, 1), 0, 0), SImode))
 	return !no_large_offset && size <= 4;
-      if (flag_pic == 1
+      if (GCC_OPTION (flag_pic) == 1
 	  && mode == Pmode
 	  && GET_CODE (XEXP (x, 1)) == UNSPEC
 	  && XINT (XEXP (x, 1), 1) == UNSPEC_LOAD_GOT
@@ -2450,7 +2450,7 @@ c6x_legitimate_address_p_1 (enum machine_mode mode, rtx x, bool strict,
       return (!no_large_offset
 	      /* With -fpic, we must wrap it in an unspec to show the B14
 		 dependency.  */
-	      && !flag_pic
+	      && !GCC_OPTION (flag_pic)
 	      && GET_MODE_SIZE (mode) <= UNITS_PER_WORD
 	      && sdata_symbolic_operand (x, Pmode));
 
@@ -2569,7 +2569,7 @@ use_push_rts_p (int nregs)
   if (TARGET_INSNS_64PLUS && optimize_function_for_size_p (cfun)
       && !cfun->machine->contains_sibcall
       && !cfun->returns_struct
-      && !TARGET_LONG_CALLS
+      && !GCC_OPTION (TARGET_LONG_CALLS)
       && nregs >= 6 && !frame_pointer_needed)
     return true;
   return false;
@@ -2758,7 +2758,7 @@ c6x_expand_prologue (void)
 
   c6x_compute_frame_layout (&frame);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = frame.to_allocate;
 
   initial_offset = -frame.to_allocate;
@@ -5894,7 +5894,7 @@ static struct hw_doloop_hooks c6x_doloop_hooks =
 static void
 c6x_hwloops (void)
 {
-  if (optimize)
+  if (GCC_OPTION (optimize))
     reorg_loops (true, &c6x_doloop_hooks);
 }
 
@@ -5908,7 +5908,7 @@ c6x_reorg (void)
 {
   basic_block bb;
   rtx *call_labels;
-  bool do_selsched = (c6x_flag_schedule_insns2 && flag_selective_scheduling2
+  bool do_selsched = (c6x_flag_schedule_insns2 && GCC_OPTION (flag_selective_scheduling2)
 		      && !maybe_skip_selective_scheduling ());
 
   /* We are freeing block_for_insn in the toplev to keep compatibility
@@ -5919,7 +5919,7 @@ c6x_reorg (void)
   df_note_add_problem ();
 
   /* If optimizing, we'll have split before scheduling.  */
-  if (optimize == 0)
+  if (GCC_OPTION (optimize) == 0)
     split_all_insns ();
 
   df_analyze ();
@@ -5995,7 +5995,7 @@ c6x_function_end (FILE *file, const char *fname)
 
   insn_info.release ();
 
-  if (!flag_inhibit_size_directive)
+  if (!GCC_OPTION (flag_inhibit_size_directive))
     ASM_OUTPUT_MEASURED_SIZE (file, fname);
 }
 
@@ -6673,7 +6673,7 @@ c6x_expand_builtin (tree exp, rtx target ATTRIBUTE_UNUSED,
 static enum unwind_info_type
 c6x_debug_unwind_info (void)
 {
-  if (flag_unwind_tables || flag_exceptions)
+  if (GCC_OPTION (flag_unwind_tables) || GCC_OPTION (flag_exceptions))
     return UI_DWARF2;
 
   return default_debug_unwind_info ();
diff --git a/gcc/config/c6x/c6x.h b/gcc/config/c6x/c6x.h
index e0a60a9..cef94c9 100644
--- a/gcc/config/c6x/c6x.h
+++ b/gcc/config/c6x/c6x.h
@@ -547,8 +547,8 @@ do { char __buf[256];					\
 /* Determine whether to place EXP (an expression or a decl) should be
    placed into one of the small data sections.  */
 #define PLACE_IN_SDATA_P(EXP) \
-  (c6x_sdata_mode == C6X_SDATA_NONE ? false	\
-   : c6x_sdata_mode == C6X_SDATA_ALL ? true	\
+  (GCC_OPTION (c6x_sdata_mode) == C6X_SDATA_NONE ? false	\
+   : GCC_OPTION (c6x_sdata_mode) == C6X_SDATA_ALL ? true	\
    : !AGGREGATE_TYPE_P (TREE_TYPE (EXP)))
 
 #define SCOMMON_ASM_OP "\t.scomm\t"
@@ -577,15 +577,15 @@ do {									\
   else									\
     switch_to_section (bss_section);					\
   ASM_OUTPUT_TYPE_DIRECTIVE (FILE, NAME, "object");			\
-  if (!flag_inhibit_size_directive)					\
+  if (!GCC_OPTION (flag_inhibit_size_directive))					\
     ASM_OUTPUT_SIZE_DIRECTIVE (FILE, NAME, SIZE);			\
   ASM_OUTPUT_ALIGN ((FILE), exact_log2((ALIGN) / BITS_PER_UNIT));	\
   ASM_OUTPUT_LABEL(FILE, NAME);						\
   ASM_OUTPUT_SKIP((FILE), (SIZE) ? (SIZE) : 1);				\
 } while (0)
 
-#define CASE_VECTOR_PC_RELATIVE flag_pic
-#define JUMP_TABLES_IN_TEXT_SECTION flag_pic
+#define CASE_VECTOR_PC_RELATIVE GCC_OPTION (flag_pic)
+#define JUMP_TABLES_IN_TEXT_SECTION GCC_OPTION (flag_pic)
 
 #define ADDR_VEC_ALIGN(VEC) (JUMP_TABLES_IN_TEXT_SECTION ? 5 : 2)
 
diff --git a/gcc/config/cr16/cr16.c b/gcc/config/cr16/cr16.c
index f5a444be..96b1e94 100644
--- a/gcc/config/cr16/cr16.c
+++ b/gcc/config/cr16/cr16.c
@@ -65,7 +65,7 @@
 /* Predicate that holds when we need to save registers even for 'noreturn'
    functions, to accommodate for unwinding.  */
 #define MUST_SAVE_REGS_P() \
-  (flag_unwind_tables || (flag_exceptions && !UI_SJLJ))
+  (GCC_OPTION (flag_unwind_tables) || (GCC_OPTION (flag_exceptions) && !UI_SJLJ))
 
 /* Nonzero if the rtx X is a signed const int of n bits.  */
 #define RTX_SIGNED_INT_FITS_N_BITS(X, n)                \
@@ -265,30 +265,30 @@ cr16_override_options (void)
      Programs which rely on NULL pointer dereferences _not_ halting the 
      program may not work properly with this option. So disable this 
      option.  */
-  flag_delete_null_pointer_checks = 0;
+  GCC_OPTION (flag_delete_null_pointer_checks) = 0;
 
   /* FIXME: To avoid spill_failure ICE during exception handling,
    * disable cse_fllow_jumps. The spill error occurs when compiler
    * can't find a suitable candidate in GENERAL_REGS class to reload
    * a 32bit register.
    * Need to find a better way of avoiding this situation. */
-  if (flag_exceptions)
-    flag_cse_follow_jumps = 0;
+  if (GCC_OPTION (flag_exceptions))
+    GCC_OPTION (flag_cse_follow_jumps) = 0;
 
   /* If -fpic option, data_model == DM_FAR.  */
-  if (flag_pic == NEAR_PIC)
+  if (GCC_OPTION (flag_pic) == NEAR_PIC)
     {
       data_model = DM_FAR;
     }
 
   /* The only option we want to examine is data model option.  */
-  if (cr16_data_model)
+  if (GCC_OPTION (cr16_data_model))
     {
-      if (strcmp (cr16_data_model, "medium") == 0)
+      if (strcmp (GCC_OPTION (cr16_data_model), "medium") == 0)
 	data_model = DM_DEFAULT;
-      else if (strcmp (cr16_data_model, "near") == 0)
+      else if (strcmp (GCC_OPTION (cr16_data_model), "near") == 0)
 	data_model = DM_NEAR;
-      else if (strcmp (cr16_data_model, "far") == 0)
+      else if (strcmp (GCC_OPTION (cr16_data_model), "far") == 0)
 	{
 	  if (TARGET_CR16CP)
 	    data_model = DM_FAR;
@@ -296,7 +296,7 @@ cr16_override_options (void)
 	    error ("data-model=far not valid for cr16c architecture");
 	}
       else
-	error ("invalid data model option -mdata-model=%s", cr16_data_model);
+	error ("invalid data model option -mdata-model=%s", GCC_OPTION (cr16_data_model));
     }
   else
     data_model = DM_DEFAULT;
@@ -306,7 +306,7 @@ cr16_override_options (void)
 static void
 cr16_conditional_register_usage (void)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       fixed_regs[12] = call_used_regs[12] = 1;
     }
@@ -1165,13 +1165,13 @@ legitimize_pic_address (rtx orig, enum machine_mode mode ATTRIBUTE_UNUSED,
       if (reg == 0)
 	reg = gen_reg_rtx (Pmode);
 
-      if (flag_pic == NEAR_PIC)
+      if (GCC_OPTION (flag_pic) == NEAR_PIC)
 	{
 	  /* Unspec to handle -fpic option.  */
 	  emit_insn (gen_unspec_bro_addr (reg, orig));
 	  emit_insn (gen_addsi3 (reg, reg, pic_offset_table_rtx));
 	}
-      else if (flag_pic == FAR_PIC)
+      else if (GCC_OPTION (flag_pic) == FAR_PIC)
 	{
 	  /* Unspec to handle -fPIC option.  */
 	  emit_insn (gen_unspec_got_addr (reg, orig));
@@ -1215,7 +1215,7 @@ cr16_legitimate_address_p (enum machine_mode mode ATTRIBUTE_UNUSED,
   enum cr16_addrtype addrtype;
   struct cr16_address address;
 
-  if (TARGET_DEBUG_ADDR)
+  if (GCC_OPTION (TARGET_DEBUG_ADDR))
     {
       fprintf (stderr,
 	       "\n======\nTARGET_LEGITIMATE_ADDRESS_P, mode = %s, strict = %d",
@@ -1223,9 +1223,9 @@ cr16_legitimate_address_p (enum machine_mode mode ATTRIBUTE_UNUSED,
       debug_rtx (addr);
     }
   addrtype = cr16_decompose_address (addr, &address,
-				     (TARGET_DEBUG_ADDR ? 1 : 0), FALSE);
+				     (GCC_OPTION (TARGET_DEBUG_ADDR) ? 1 : 0), FALSE);
 
-  if (TARGET_DEBUG_ADDR)
+  if (GCC_OPTION (TARGET_DEBUG_ADDR))
     {
       const char *typestr;
 
@@ -1260,20 +1260,20 @@ cr16_legitimate_address_p (enum machine_mode mode ATTRIBUTE_UNUSED,
       if (address.base
 	  && !REGNO_MODE_OK_FOR_BASE_P (REGNO (address.base), mode))
 	{
-	  if (TARGET_DEBUG_ADDR)
+	  if (GCC_OPTION (TARGET_DEBUG_ADDR))
 	    fprintf (stderr, "base register not strict\n");
 	  return FALSE;
 	}
       if (address.index && !REGNO_OK_FOR_INDEX_P (REGNO (address.index)))
 	{
-	  if (TARGET_DEBUG_ADDR)
+	  if (GCC_OPTION (TARGET_DEBUG_ADDR))
 	    fprintf (stderr, "index register not strict\n");
 	  return FALSE;
 	}
     }
 
   /* Return true if addressing mode is register relative.  */
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       if (addrtype == CR16_REG_REL || addrtype == CR16_REGP_REL)
 	return TRUE;
@@ -1328,7 +1328,7 @@ cr16_address_cost (rtx addr, enum machine_mode mode ATTRIBUTE_UNUSED,
       break;
     }
 
-  if (TARGET_DEBUG_ADDR)
+  if (GCC_OPTION (TARGET_DEBUG_ADDR))
     {
       fprintf (stderr, "\n======\nmacro TARGET_ADDRESS_COST = %d\n", cost);
       debug_rtx (addr);
@@ -1603,7 +1603,7 @@ cr16_print_operand_address (FILE * file, rtx addr)
       gcc_unreachable ();
     }
   /* Add qualifiers to the address expression that was just printed.  */
-  if (flag_pic < NEAR_PIC && address.code == 0)
+  if (GCC_OPTION (flag_pic) < NEAR_PIC && address.code == 0)
     {
       if (address.data == DM_FAR)
 	/* Addr contains SYMBOL_REF & far data ptr.  */
@@ -1616,23 +1616,23 @@ cr16_print_operand_address (FILE * file, rtx addr)
 	/* Addr contains SYMBOL_REF & near data ptr.  */
 	fprintf (file, "@s");
     }
-  else if (flag_pic == NEAR_PIC
+  else if (GCC_OPTION (flag_pic) == NEAR_PIC
 	   && (address.code == 0) && (address.data == DM_FAR
 				      || address.data == DM_DEFAULT
 				      || address.data == DM_NEAR))
     {
       fprintf (file, "@l");
     }
-  else if (flag_pic == NEAR_PIC && address.code == 2)
+  else if (GCC_OPTION (flag_pic) == NEAR_PIC && address.code == 2)
     {
       fprintf (file, "pic");
     }
-  else if (flag_pic == NEAR_PIC && address.code == 1)
+  else if (GCC_OPTION (flag_pic) == NEAR_PIC && address.code == 1)
     {
       fprintf (file, "@cpic");
     }
 
-  else if (flag_pic == FAR_PIC && address.code == 2)
+  else if (GCC_OPTION (flag_pic) == FAR_PIC && address.code == 2)
     {
       /* REVISIT: cr16 register indirect jump expects a 1-bit right shifted
          address ! GOTc tells assembler this symbol is a text-address 
@@ -1643,12 +1643,12 @@ cr16_print_operand_address (FILE * file, rtx addr)
          processor.  */
       fprintf (file, "GOT (%s)", reg_names[PIC_OFFSET_TABLE_REGNUM]);
     }
-  else if (flag_pic == FAR_PIC && address.code == 1)
+  else if (GCC_OPTION (flag_pic) == FAR_PIC && address.code == 1)
     {
       fprintf (file, "@cGOT (%s)", reg_names[PIC_OFFSET_TABLE_REGNUM]);
     }
 
-  else if (flag_pic == FAR_PIC &&
+  else if (GCC_OPTION (flag_pic) == FAR_PIC &&
 	   (address.data == DM_FAR || address.data == DM_DEFAULT
 	    || address.data == DM_NEAR))
     {
@@ -2049,7 +2049,7 @@ static rtx
 cr16_legitimize_address (rtx x, rtx orig_x ATTRIBUTE_UNUSED,
 			 enum machine_mode mode ATTRIBUTE_UNUSED)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     return legitimize_pic_address (orig_x, mode, NULL_RTX);
   else
     return x;
diff --git a/gcc/config/cris/cris.c b/gcc/config/cris/cris.c
index 209f127..04a1e07 100644
--- a/gcc/config/cris/cris.c
+++ b/gcc/config/cris/cris.c
@@ -470,7 +470,7 @@ cris_conditional_register_usage (void)
 {
   /* FIXME: This isn't nice.  We should be able to use that register for
      something else if the PIC table isn't needed.  */
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     fixed_regs[PIC_OFFSET_TABLE_REGNUM]
       = call_used_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
 
@@ -684,7 +684,7 @@ cris_reg_saved_in_regsave_area (unsigned int regno, bool got_really_used)
       || (regno == PIC_OFFSET_TABLE_REGNUM
 	  && (got_really_used
 	      /* It is saved anyway, if there would be a gap.  */
-	      || (flag_pic
+	      || (GCC_OPTION (flag_pic)
 		  && df_regs_ever_live_p (regno + 1)
 		  && !call_used_regs[regno + 1]))))
      && (regno != FRAME_POINTER_REGNUM || !frame_pointer_needed)
@@ -833,7 +833,7 @@ cris_print_operand (FILE *file, rtx x, int code)
     case 'Z':
       /* If this is a GOT-symbol, print the size-letter corresponding to
 	 -fpic/-fPIC.  For everything else, print "d".  */
-      putc ((flag_pic == 1
+      putc ((GCC_OPTION (flag_pic) == 1
 	     && GET_CODE (x) == CONST
 	     && GET_CODE (XEXP (x, 0)) == UNSPEC
 	     && XINT (XEXP (x, 0), 1) == CRIS_UNSPEC_GOTREAD)
@@ -859,14 +859,14 @@ cris_print_operand (FILE *file, rtx x, int code)
 	 (supposed) muls/mulu insn isn't located at the end of a
 	 cache-line.  */
       if (TARGET_MUL_BUG)
-	fputs (optimize_size
+	fputs (GCC_OPTION (optimize_size)
 	       ? ".p2alignw 2,0x050f\n\t"
 	       : ".p2alignw 5,0x050f,2\n\t", file);
       return;
 
     case ':':
       /* The PIC register.  */
-      if (! flag_pic)
+      if (! GCC_OPTION (flag_pic))
 	internal_error ("invalid use of ':' modifier");
       fprintf (file, "$%s", reg_names [PIC_OFFSET_TABLE_REGNUM]);
       return;
@@ -1041,13 +1041,13 @@ cris_print_operand (FILE *file, rtx x, int code)
       /* If this is a GOT symbol, force it to be emitted as :GOT and
 	 :GOTPLT regardless of -fpic (i.e. not as :GOT16, :GOTPLT16).
 	 Avoid making this too much of a special case.  */
-      if (flag_pic == 1 && CONSTANT_P (operand))
+      if (GCC_OPTION (flag_pic) == 1 && CONSTANT_P (operand))
 	{
-	  int flag_pic_save = flag_pic;
+	  int flag_pic_save = GCC_OPTION (flag_pic);
 
-	  flag_pic = 2;
+	  GCC_OPTION (flag_pic) = 2;
 	  cris_output_addr_const (file, operand);
-	  flag_pic = flag_pic_save;
+	  GCC_OPTION (flag_pic) = flag_pic_save;
 	  return;
 	}
       break;
@@ -1076,7 +1076,7 @@ cris_print_operand (FILE *file, rtx x, int code)
 
     case 'u':
       /* Print "u.w" if a GOT symbol and flag_pic == 1, else ".d".  */
-      if (flag_pic == 1
+      if (GCC_OPTION (flag_pic) == 1
 	  && GET_CODE (operand) == CONST
 	  && GET_CODE (XEXP (operand, 0)) == UNSPEC
 	  && XINT (XEXP (operand, 0), 1) == CRIS_UNSPEC_GOTREAD)
@@ -1358,7 +1358,7 @@ reg_ok_for_index_p (const_rtx x, bool strict)
 bool
 cris_constant_index_p (const_rtx x)
 {
-  return (CONSTANT_P (x) && (!flag_pic || cris_valid_pic_const (x, true)));
+  return (CONSTANT_P (x) && (!GCC_OPTION (flag_pic) || cris_valid_pic_const (x, true)));
 }
 
 /* True if X is a valid base register.  */
@@ -2423,7 +2423,7 @@ cris_reg_overlap_mentioned_p (rtx x, rtx in)
 bool
 cris_valid_pic_const (const_rtx x, bool any_operand)
 {
-  gcc_assert (flag_pic);
+  gcc_assert (GCC_OPTION (flag_pic));
 
   switch (GET_CODE (x))
     {
@@ -2586,9 +2586,9 @@ cris_asm_output_case_end (FILE *stream, int num, rtx table)
 static void
 cris_option_override (void)
 {
-  if (cris_max_stackframe_str)
+  if (GCC_OPTION (cris_max_stackframe_str))
     {
-      cris_max_stackframe = atoi (cris_max_stackframe_str);
+      cris_max_stackframe = atoi (GCC_OPTION (cris_max_stackframe_str));
 
       /* Do some sanity checking.  */
       if (cris_max_stackframe < 0 || cris_max_stackframe > 0x20000000)
@@ -2603,33 +2603,33 @@ cris_option_override (void)
     cris_cpu_version = CRIS_CPU_ETRAX4;
 
   /* Parse -march=... and its synonym, the deprecated -mcpu=...  */
-  if (cris_cpu_str)
+  if (GCC_OPTION (cris_cpu_str))
     {
       cris_cpu_version
-	= (*cris_cpu_str == 'v' ? atoi (cris_cpu_str + 1) : -1);
+	= (*GCC_OPTION (cris_cpu_str) == 'v' ? atoi (GCC_OPTION (cris_cpu_str) + 1) : -1);
 
-      if (strcmp ("etrax4", cris_cpu_str) == 0)
+      if (strcmp ("etrax4", GCC_OPTION (cris_cpu_str)) == 0)
 	cris_cpu_version = 3;
 
-      if (strcmp ("svinto", cris_cpu_str) == 0
-	  || strcmp ("etrax100", cris_cpu_str) == 0)
+      if (strcmp ("svinto", GCC_OPTION (cris_cpu_str)) == 0
+	  || strcmp ("etrax100", GCC_OPTION (cris_cpu_str)) == 0)
 	cris_cpu_version = 8;
 
-      if (strcmp ("ng", cris_cpu_str) == 0
-	  || strcmp ("etrax100lx", cris_cpu_str) == 0)
+      if (strcmp ("ng", GCC_OPTION (cris_cpu_str)) == 0
+	  || strcmp ("etrax100lx", GCC_OPTION (cris_cpu_str)) == 0)
 	cris_cpu_version = 10;
 
       if (cris_cpu_version < 0 || cris_cpu_version > 32)
 	error ("unknown CRIS version specification in -march= or -mcpu= : %s",
-	       cris_cpu_str);
+	       GCC_OPTION (cris_cpu_str));
 
       /* Set the target flags.  */
       if (cris_cpu_version >= CRIS_CPU_ETRAX4)
-	target_flags |= MASK_ETRAX4_ADD;
+	GCC_OPTION (target_flags) |= MASK_ETRAX4_ADD;
 
       /* If this is Svinto or higher, align for 32 bit accesses.  */
       if (cris_cpu_version >= CRIS_CPU_SVINTO)
-	target_flags
+	GCC_OPTION (target_flags)
 	  |= (MASK_SVINTO | MASK_ALIGN_BY_32
 	      | MASK_STACK_ALIGN | MASK_CONST_ALIGN
 	      | MASK_DATA_ALIGN);
@@ -2639,38 +2639,38 @@ cris_option_override (void)
 	 TARGET_HAS_MUL_INSNS is (cris_cpu_version >= CRIS_CPU_NG).  */
     }
 
-  if (cris_tune_str)
+  if (GCC_OPTION (cris_tune_str))
     {
       int cris_tune
-	= (*cris_tune_str == 'v' ? atoi (cris_tune_str + 1) : -1);
+	= (*GCC_OPTION (cris_tune_str) == 'v' ? atoi (GCC_OPTION (cris_tune_str) + 1) : -1);
 
-      if (strcmp ("etrax4", cris_tune_str) == 0)
+      if (strcmp ("etrax4", GCC_OPTION (cris_tune_str)) == 0)
 	cris_tune = 3;
 
-      if (strcmp ("svinto", cris_tune_str) == 0
-	  || strcmp ("etrax100", cris_tune_str) == 0)
+      if (strcmp ("svinto", GCC_OPTION (cris_tune_str)) == 0
+	  || strcmp ("etrax100", GCC_OPTION (cris_tune_str)) == 0)
 	cris_tune = 8;
 
-      if (strcmp ("ng", cris_tune_str) == 0
-	  || strcmp ("etrax100lx", cris_tune_str) == 0)
+      if (strcmp ("ng", GCC_OPTION (cris_tune_str)) == 0
+	  || strcmp ("etrax100lx", GCC_OPTION (cris_tune_str)) == 0)
 	cris_tune = 10;
 
       if (cris_tune < 0 || cris_tune > 32)
 	error ("unknown CRIS cpu version specification in -mtune= : %s",
-	       cris_tune_str);
+	       GCC_OPTION (cris_tune_str));
 
       if (cris_tune >= CRIS_CPU_SVINTO)
 	/* We have currently nothing more to tune than alignment for
 	   memory accesses.  */
-	target_flags
+	GCC_OPTION (target_flags)
 	  |= (MASK_STACK_ALIGN | MASK_CONST_ALIGN
 	      | MASK_DATA_ALIGN | MASK_ALIGN_BY_32);
     }
 
   if (cris_cpu_version >= CRIS_CPU_V32)
-    target_flags &= ~(MASK_SIDE_EFFECT_PREFIXES|MASK_MUL_BUG);
+    GCC_OPTION (target_flags) &= ~(MASK_SIDE_EFFECT_PREFIXES|MASK_MUL_BUG);
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       /* Use error rather than warning, so invalid use is easily
 	 detectable.  Still change to the values we expect, to avoid
@@ -2678,7 +2678,7 @@ cris_option_override (void)
       if (! TARGET_LINUX)
 	{
 	  error ("-fPIC and -fpic are not supported in this configuration");
-	  flag_pic = 0;
+	  GCC_OPTION (flag_pic) = 0;
 	}
 
       /* Turn off function CSE.  We need to have the addresses reach the
@@ -2687,7 +2687,7 @@ cris_option_override (void)
 	 call expanders they will then be cse:ed, as the call expanders
 	 force_reg the addresses, effectively forcing flag_no_function_cse
 	 to 0.  */
-      flag_no_function_cse = 1;
+      GCC_OPTION (flag_no_function_cse) = 1;
     }
 
   /* Set the per-function-data initializer.  */
@@ -2715,7 +2715,7 @@ cris_asm_output_mi_thunk (FILE *stream,
 	     ADDITIVE_SIZE_MODIFIER (-delta), -delta,
 	     reg_names[CRIS_FIRST_ARG_REG]);
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       const char *name = XSTR (XEXP (DECL_RTL (funcdecl), 0), 0);
 
@@ -2757,7 +2757,7 @@ cris_file_start (void)
 {
   /* These expressions can vary at run time, so we cannot put
      them into TARGET_INITIALIZER.  */
-  targetm.asm_file_start_app_off = !(TARGET_PDEBUG || flag_print_asm_name);
+  targetm.asm_file_start_app_off = !(TARGET_PDEBUG || GCC_OPTION (flag_print_asm_name));
 
   default_file_start ();
 }
@@ -3864,7 +3864,7 @@ cris_asm_output_symbol_ref (FILE *file, rtx x)
 {
   gcc_assert (GET_CODE (x) == SYMBOL_REF);
 
-  if (flag_pic && in_code > 0)
+  if (GCC_OPTION (flag_pic) && in_code > 0)
     {
      const char *origstr = XSTR (x, 0);
      const char *str;
@@ -3884,7 +3884,7 @@ cris_asm_output_symbol_ref (FILE *file, rtx x)
 void
 cris_asm_output_label_ref (FILE *file, char *buf)
 {
-  if (flag_pic && in_code > 0)
+  if (GCC_OPTION (flag_pic) && in_code > 0)
     {
       assemble_name (file, buf);
 
@@ -3918,7 +3918,7 @@ cris_output_addr_const_extra (FILE *file, rtx xconst)
 	  /* We only get this with -fpic/PIC to tell it apart from an
 	     invalid symbol.  We can't tell here, but it should only
 	     be the operand of a call or movsi.  */
-	  gcc_assert (TARGET_V32 && flag_pic);
+	  gcc_assert (TARGET_V32 && GCC_OPTION (flag_pic));
 	  break;
 
 	case CRIS_UNSPEC_PLT_PCREL:
@@ -3937,14 +3937,14 @@ cris_output_addr_const_extra (FILE *file, rtx xconst)
 	  break;
 
 	case CRIS_UNSPEC_GOTREAD:
-	  if (flag_pic == 1)
+	  if (GCC_OPTION (flag_pic) == 1)
 	    fprintf (file, ":GOT16");
 	  else
 	    fprintf (file, ":GOT");
 	  break;
 
 	case CRIS_UNSPEC_PLTGOTREAD:
-	  if (flag_pic == 1)
+	  if (GCC_OPTION (flag_pic) == 1)
 	    fprintf (file, CRIS_GOTPLT_SUFFIX "16");
 	  else
 	    fprintf (file, CRIS_GOTPLT_SUFFIX);
diff --git a/gcc/config/cris/cris.h b/gcc/config/cris/cris.h
index 37b562e..ff801fb 100644
--- a/gcc/config/cris/cris.h
+++ b/gcc/config/cris/cris.h
@@ -313,12 +313,12 @@ extern int cris_cpu_version;
 
 /* The "break" instruction was introduced with ETRAX 4.  */
 #define TARGET_TRAP_USING_BREAK8 \
- (cris_trap_using_break8 == 2 ? TARGET_HAS_BREAK : cris_trap_using_break8)
+ (GCC_OPTION (cris_trap_using_break8) == 2 ? TARGET_HAS_BREAK : GCC_OPTION (cris_trap_using_break8))
 
 /* Call library functions by default for GNU/Linux.  */
 #define TARGET_ATOMICS_MAY_CALL_LIBFUNCS		\
- (cris_atomics_calling_libfunc == 2			\
-  ? TARGET_LINUX : cris_atomics_calling_libfunc)
+ (GCC_OPTION (cris_atomics_calling_libfunc) == 2			\
+  ? TARGET_LINUX : GCC_OPTION (cris_atomics_calling_libfunc))
 
 /* The < v10 atomics turn off interrupts, so they don't need alignment.
    Incidentally, by default alignment is off there causing variables to
@@ -326,9 +326,9 @@ extern int cris_cpu_version;
    libraries use a proper atomic type (instead of "int"), one we'd
    specify as aligned.  */
 #define TARGET_TRAP_UNALIGNED_ATOMIC		\
- (cris_trap_unaligned_atomic == 2		\
+ (GCC_OPTION (cris_trap_unaligned_atomic) == 2		\
   ? (TARGET_V32 || cris_cpu_version == 10)	\
-  : cris_trap_unaligned_atomic)
+  : GCC_OPTION (cris_trap_unaligned_atomic))
 
 /* Node: Storage Layout */
 
@@ -842,7 +842,7 @@ enum cris_pic_symbol_type
     cris_invalid_pic_symbol = 4
   };
 
-#define PIC_OFFSET_TABLE_REGNUM (flag_pic ? CRIS_GOT_REGNUM : INVALID_REGNUM)
+#define PIC_OFFSET_TABLE_REGNUM (GCC_OPTION (flag_pic) ? CRIS_GOT_REGNUM : INVALID_REGNUM)
 
 #define LEGITIMATE_PIC_OPERAND_P(X) cris_legitimate_pic_operand (X)
 
diff --git a/gcc/config/cris/linux.h b/gcc/config/cris/linux.h
index af27e10..5624af3 100644
--- a/gcc/config/cris/linux.h
+++ b/gcc/config/cris/linux.h
@@ -123,7 +123,7 @@ along with GCC; see the file COPYING3.  If not see
   do						\
     {						\
       GNU_USER_TARGET_OS_CPP_BUILTINS();	\
-      if (flag_leading_underscore <= 0)		\
+      if (GCC_OPTION (flag_leading_underscore) <= 0)		\
 	builtin_define ("__NO_UNDERSCORES__");	\
     }						\
   while (0)
